/*
 * Copyright (c) 2003 [NAMES_GO_HERE]
 *                    Massachusetts Institute of Technology
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include "p2psim/threadmanager.h"
#include "simevent.h"
#include "p2psim/eventqueue.h"
#include <iostream>
using namespace std;

SimEvent::SimEvent() : Event( "SimEvent" )
{
}

SimEvent::SimEvent(vector<string> *v) : Event("SimEvent", v)
{
  this->_op = (*v)[0];
}

SimEvent::~SimEvent()
{
}

void
SimEvent::execute()
{
  if(_op == "exit") {
    DEBUG(1) << "simulation exits at the end of cycle " << now() << "." << endl;
    ThreadManager::Instance()->create(&::graceful_exit, (void *)0);
    //i like ugly exit
    //exit(1);
  } else
    cerr << "SimEvent::execute(): unknown op " << _op << "\n";
}
